import { FocusEvent, HTMLAttributes, ReactNode } from 'react';
export interface UseFocusProps<T = HTMLElement> {
    disabled?: boolean;
    onFocus?: (event: FocusEvent<T>) => void;
    onBlur?: (event: FocusEvent<T>) => void;
    onFocusChange?: (isFocused: boolean) => void;
    children?: ReactNode;
}
export interface UseFocusResult<T> {
    focusProps: HTMLAttributes<T>;
}
export declare function useFocus<T extends HTMLElement>(props: UseFocusProps<T>): UseFocusResult<T>;
