import { useCallback, useRef } from 'react';
export function useFocus(props) {
    var propsRef = useRef(props);
    propsRef.current = props;
    var onFocus = useCallback(function (event) {
        var _a = propsRef.current, onFocus = _a.onFocus, onFocusChange = _a.onFocusChange;
        if (event.target === event.currentTarget) {
            onFocus === null || onFocus === void 0 ? void 0 : onFocus(event);
            onFocusChange === null || onFocusChange === void 0 ? void 0 : onFocusChange(true);
        }
    }, []);
    var onBlur = useCallback(function (event) {
        var _a = propsRef.current, onBlur = _a.onBlur, onFocusChange = _a.onFocusChange;
        if (event.target === event.currentTarget) {
            onBlur === null || onBlur === void 0 ? void 0 : onBlur(event);
            onFocusChange === null || onFocusChange === void 0 ? void 0 : onFocusChange(false);
        }
    }, []);
    var focusProps = {};
    if (!props.disabled) {
        if (props.onFocus || props.onFocusChange) {
            focusProps.onFocus = onFocus;
        }
        if (props.onBlur || props.onFocusChange) {
            focusProps.onBlur = onBlur;
        }
    }
    return {
        focusProps: focusProps,
    };
}
