import { useEffect, useRef } from 'react';
function isEssentionalClick(refs, target) {
    return refs.some(function (ref) {
        return ref.current instanceof HTMLElement && ref.current.contains(target);
    });
}
export function useOutsideClick(props) {
    var onAction = props.onAction, refs = props.refs, triggerStrategy = props.triggerStrategy, disabled = props.disabled;
    var partialPropsRef = useRef({
        onAction: onAction,
        refs: refs,
    });
    partialPropsRef.current = { onAction: onAction, refs: refs };
    useEffect(function () {
        var currentTarget = null;
        var targetCapturer = function (event) {
            currentTarget = event.target;
        };
        var eventType = triggerStrategy === 'pressup' ? 'click' : 'pointerdown';
        var listener = function (event) {
            if (event.button > 0 || disabled) {
                return;
            }
            if (triggerStrategy === 'pressup') {
                var isSameTarget = currentTarget === event.target;
                currentTarget = null;
                if (!isSameTarget) {
                    return;
                }
            }
            if (!isEssentionalClick(partialPropsRef.current.refs, event.target)) {
                partialPropsRef.current.onAction(event);
            }
        };
        document.addEventListener(eventType, listener);
        document.addEventListener('pointerdown', targetCapturer);
        return function () {
            document.removeEventListener(eventType, listener);
            document.removeEventListener('pointerdown', targetCapturer);
        };
    }, [triggerStrategy, disabled]);
}
