export function isCheckableInput(element) {
    var type = element.getAttribute('type');
    return element.tagName === 'INPUT' && (type === 'checkbox' || type === 'radio');
}
export function isValidKeyboardEvent(event) {
    var key = event.key, target = event.target;
    var element = target;
    var role = element.getAttribute('role');
    var isLink = element.tagName === 'A' && element.hasAttribute('href');
    // Use getAttribute instead isContentEditable because jsdom doesn't support this attr.
    var contentEditable = element.getAttribute('contenteditable');
    // Accessibility for keyboards. Space and Enter only ("Spacebar" is for IE 11).
    return (
    // An checkable input should only trigger with Space key.
    ((!isCheckableInput(element) && key === 'Enter') || key === ' ' || key === 'Spacebar') &&
        contentEditable !== 'true' &&
        // A link with a valid href should be handled natively,
        // unless it also has role='button' and was triggered using Space.
        (!isLink || (role === 'button' && key !== 'Enter')) &&
        // An element with role='link' should only trigger with Enter key.
        !(role === 'link' && key !== 'Enter'));
}
