export { renderHook } from '@testing-library/react-hooks';
export * from './createClientRender';
export * from './createServerRender';
export * from './events';
export declare const fireEvent: {
    setup: (options: import("@testing-library/user-event/dist/types/options").Options) => import("@testing-library/user-event/dist/types/setup/setup").UserEvent;
    click: (element: Element) => Promise<void>;
    dblClick: (element: Element) => Promise<void>;
    tripleClick: (element: Element) => Promise<void>;
    hover: (element: Element) => Promise<void>;
    unhover: (element: Element) => Promise<void>;
    tab: (args_0?: {
        shift?: boolean | undefined;
    } | undefined) => Promise<void>;
    keyboard: (text: string) => Promise<void>;
    copy: () => Promise<DataTransfer | undefined>;
    cut: () => Promise<DataTransfer | undefined>;
    paste: (clipboardData?: string | DataTransfer | undefined) => Promise<void>;
    pointer: (input: import("@testing-library/user-event/dist/types/pointer").PointerInput) => Promise<void>;
    clear: (element: Element) => Promise<void>;
    deselectOptions: (select: Element, values: string | string[] | HTMLElement | HTMLElement[]) => Promise<void>;
    selectOptions: (select: Element, values: string | string[] | HTMLElement | HTMLElement[]) => Promise<void>;
    type: (args_0: Element, args_1: string, args_2?: import("@testing-library/user-event/dist/types/utility").typeOptions | undefined) => Promise<void>;
    upload: (element: HTMLElement, fileOrFiles: File | File[]) => Promise<void>;
    input: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    progress: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    error: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    pause: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    play: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    waiting: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    abort: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    ended: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    resize: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    select: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    blur: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    change: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    drag: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    drop: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    emptied: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    focus: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    invalid: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    load: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    playing: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    reset: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    scroll: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    seeked: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    seeking: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    stalled: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    submit: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    suspend: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    wheel: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    encrypted: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    contextMenu: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    compositionEnd: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    compositionStart: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    compositionUpdate: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    keyDown: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    keyPress: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    keyUp: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    focusIn: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    focusOut: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    dragEnd: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    dragEnter: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    dragExit: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    dragLeave: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    dragOver: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    dragStart: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    mouseDown: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    mouseEnter: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    mouseLeave: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    mouseMove: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    mouseOut: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    mouseOver: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    mouseUp: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    popState: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    touchCancel: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    touchEnd: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    touchMove: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    touchStart: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    canPlay: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    canPlayThrough: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    durationChange: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    loadedData: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    loadedMetadata: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    loadStart: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    rateChange: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    timeUpdate: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    volumeChange: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    animationStart: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    animationEnd: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    animationIteration: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    transitionCancel: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    transitionEnd: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    transitionRun: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    transitionStart: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    doubleClick: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    pointerOver: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    pointerEnter: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    pointerDown: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    pointerMove: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    pointerUp: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    pointerCancel: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    pointerOut: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    pointerLeave: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    gotPointerCapture: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
    lostPointerCapture: (element: Element | Node | Document | Window, options?: {} | undefined) => boolean;
};
export declare function createContainer(html: string): HTMLDivElement;
