import { useCallback, useEffect, useRef } from 'react';
/* eslint-enable no-undef */
export function useListeners() {
    var globalListeners = useRef(new Map());
    /* eslint-disable no-undef */
    var addListener = useCallback(function (eventTarget, type, listener, options) {
        /* eslint-enable no-undef */
        globalListeners.current.set(listener, { type: type, eventTarget: eventTarget, options: options });
        eventTarget.addEventListener(type, listener, options);
    }, []);
    /* eslint-disable no-undef */
    var removeListener = useCallback(function (eventTarget, type, listener, options) {
        /* eslint-enable no-undef */
        eventTarget.removeEventListener(type, listener, options);
        globalListeners.current.delete(listener);
    }, []);
    var removeAllListeners = useCallback(function () {
        globalListeners.current.forEach(function (value, key) {
            removeListener(value.eventTarget, value.type, key, value.options);
        });
    }, [removeListener]);
    useEffect(function () {
        return removeAllListeners;
    }, [removeAllListeners]);
    return { addListener: addListener, removeListener: removeListener, removeAllListeners: removeAllListeners };
}
