import { FocusTrapManager } from './FocusTrapManager';
import { FocusTrapInstance, FocusTrapOptions } from './types';
export declare class FocusTrap implements FocusTrapInstance {
    private manager;
    private options;
    private scope;
    private active;
    private cleanupFns;
    constructor(manager: FocusTrapManager, scope: HTMLElement, options?: FocusTrapOptions);
    /**
     * Returns trapped html element.
     */
    getScope(): HTMLElement;
    /**
     * Activates focus trap.
     */
    activate(): void;
    /**
     * Deactivates focus trap.
     */
    deactivate(): void;
    /**
     * Returns focus trap options.
     */
    getOptions(): FocusTrapOptions;
    /**
     * Sets focus trap options.
     */
    setOptions(options: FocusTrapOptions): void;
    private attachGuards;
    private activateInManager;
}
/**
 * Creates focus trap for selected dom-node.
 *
 * @example
 * createFocusTrap(scopeDomNode, { autoFocus: true })
 */
export declare function createFocusTrap(scope: HTMLElement, options?: FocusTrapOptions): FocusTrap;
