import { __read } from "tslib";
import { focusElement } from '../../dom-utils';
import { getTabbables } from './tabbable';
var FOCUS_TRAP_GUARD_ATTR = 'focusTrapGuard';
export function getActiveElement() {
    return document.activeElement;
}
export function isElementInScope(scope, element) {
    return scope.contains(element);
}
export function isFocusFree() {
    return getActiveElement() === document.body;
}
export function createGuard(tabIndex) {
    var element = document.createElement('span');
    element.tabIndex = tabIndex;
    Object.assign(element.style, {
        width: '1px',
        height: 0,
        padding: 0,
        overflow: 'hidden',
        position: 'fixed',
        top: '1px',
        left: '1px',
    });
    element.setAttribute('aria-hidden', 'true');
    element.dataset[FOCUS_TRAP_GUARD_ATTR] = 'true';
    return element;
}
export function isGuard(node) {
    return Boolean(node.dataset[FOCUS_TRAP_GUARD_ATTR]);
}
export function removeElementFromDocument(element) {
    if (!element.parentNode) {
        return;
    }
    element.parentNode.removeChild(element);
}
export function focusFirstIn(scope) {
    var _a = __read(getTabbables(scope, function (node) { return !isGuard(node); }), 1), first = _a[0];
    focusElement(first);
}
export function getNextTabbableIndex(current, count, step) {
    if (current === -1) {
        return 0;
    }
    return count > 0 ? (count + current + step) % count : -1;
}
