import { isHidden } from '../dom-utils';
import { isHiddenInput, matches } from './utils';
var FOCUSABLE_SELECTORS = [
    '[contenteditable]:not([contenteditable="false"])',
    '[tabindex]',
    'a[href]',
    'area[href]',
    'audio[controls]',
    'button',
    'details',
    'details>summary:first-of-type',
    'input',
    'select',
    'textarea',
    'video[controls]',
    'iframe',
].join(',');
export function isFocusable(node) {
    if (!matches(node, FOCUSABLE_SELECTORS) ||
        isHiddenInput(node) ||
        node.disabled ||
        isHidden(node)) {
        return false;
    }
    return true;
}
