var protoMatches = null;
if (typeof Element !== 'undefined') {
    protoMatches =
        Element.prototype.matches ||
            Element.prototype.webkitMatchesSelector ||
            // @ts-expect-error
            Element.prototype.matchesSelector ||
            // @ts-expect-error
            Element.prototype.mozMatchesSelector ||
            // @ts-expect-error
            Element.prototype.msMatchesSelector;
}
export function matches(node, selectors) {
    return protoMatches ? protoMatches.call(node, selectors) : false;
}
export function isInput(node) {
    return node.tagName === 'INPUT';
}
export function isIframe(node) {
    return node.tagName === 'IFRAME';
}
export function isHiddenInput(node) {
    return isInput(node) && node.type === 'hidden';
}
export function isRadioInput(node) {
    return isInput(node) && node.type === 'radio';
}
