import React from 'react';
import { createSlot, useSlots } from '..';
var FooterSlot = createSlot('footer');
var Example = function (props) {
    var slots = useSlots(props);
    var footer = slots.get(FooterSlot);
    return (React.createElement("div", null,
        React.createElement("main", null, slots.children),
        footer && (React.createElement("footer", { style: {
                display: 'flex',
                flexDirection: 'column',
                alignItems: footer.props.align,
            } }, footer.rendered))));
};
export var SlotProps = function (args) {
    return (React.createElement(Example, null,
        React.createElement("p", null, "A paragraph for the main content."),
        React.createElement("p", null, "And another one."),
        React.createElement(FooterSlot, { align: args.footerAlign },
            React.createElement("p", null, "Here's some contact info"))));
};
SlotProps.argTypes = {
    footerAlign: {
        control: {
            type: 'select',
            options: ['flex-start', 'center', 'flex-end'],
        },
        defaultValue: 'flex-start',
    },
};
