import { useMemo } from 'react';
import { SlotMap } from './SlotMap';
export function useSlots(props, options) {
    if (options === void 0) { options = {}; }
    var children = props.children;
    var defaultSlot = options.defaultSlot;
    var slots = useMemo(function () {
        return new SlotMap(children, { defaultSlot: defaultSlot });
    }, [children, defaultSlot]);
    return slots;
}
