import React, { FC, PropsWithChildren } from 'react';
export interface SSRContextValue {
    /**
     * Current counter value into context
     */
    value: number;
    /**
     * Context ID, used for nested `SSRProvider`
     */
    id: number;
}
export declare const SSRContext: React.Context<SSRContextValue>;
/**
 * Provider that synchronizes the layout data when the application is hydrated.
 *
 * @example
 * const Root = () => (
 *   <SSRProvider>
 *     <App />
 *   </SSRProvider>
 * )
 */
export declare const SSRProvider: FC<PropsWithChildren>;
