import { ElementType, HTMLAttributes, RefObject } from 'react';
import type { SharedButtonProps } from '../../shared/types';
export interface UseButtonProps<T extends HTMLElement = HTMLElement> extends SharedButtonProps<T> {
    elementType?: Extract<ElementType, string>;
}
export interface UseButtonResult<T> {
    isPressed: boolean;
    buttonProps: HTMLAttributes<T>;
}
export declare function useButton<T extends HTMLElement = HTMLElement>(props: UseButtonProps<T>, ref: RefObject<T>): UseButtonResult<T>;
