import { useFocusable } from '../../interactions/focusable';
import { usePress } from '../../interactions/press';
import { mergeProps } from '../../libs/merge-props';
import { isFirefox } from '../../libs/platform';
export function useButton(props, ref) {
    var _a = props.elementType, elementType = _a === void 0 ? 'button' : _a, disabled = props.disabled, href = props.href, target = props.target, rel = props.rel, _b = props.type, type = _b === void 0 ? 'button' : _b, tabIndex = props.tabIndex, _onPress = props.onPress, _onPressEnd = props.onPressEnd, _onPressStart = props.onPressStart, _onPressUp = props.onPressUp, _preventFocusOnPress = props.preventFocusOnPress;
    var additionalProps;
    if (elementType === 'button') {
        additionalProps = { type: type, disabled: disabled };
        if (isFirefox()) {
            // https://bugzilla.mozilla.org/show_bug.cgi?id=654072
            additionalProps.autoComplete = 'off';
        }
    }
    else {
        additionalProps = {
            'aria-disabled': disabled ? disabled : undefined,
            role: 'button',
            tabIndex: tabIndex || 0,
        };
        if (elementType === 'a') {
            additionalProps.href = disabled ? undefined : href;
            additionalProps.rel = rel;
            additionalProps.target = target;
        }
    }
    var focusableProps = useFocusable(props, ref).focusableProps;
    var _c = usePress(props), isPressed = _c.isPressed, pressProps = _c.pressProps;
    return {
        buttonProps: mergeProps(additionalProps, focusableProps, pressProps, {
            'aria-pressed': props['aria-pressed'],
            'aria-haspopup': props['aria-haspopup'],
            'aria-controls': props['aria-controls'],
            'aria-expanded': props['aria-expanded'],
            'aria-label': props['aria-label'],
            'aria-labelledby': props['aria-labelledby'],
        }),
        isPressed: isPressed,
    };
}
