import { addMonths, addYears, setMonth, subMonths, subYears } from '../../../internal/date';
import { CalendarNavigationAction } from '../types';
var MONTH_VIEW_ROW_COUNT = 4;
var MONTH_VIEW_COL_COUNT = 3;
export function durationInMonthViews(start, end) {
    return end.getFullYear() - start.getFullYear();
}
export function getMonthViewData(viewDate) {
    var data = [];
    for (var row = 0, index = 0; row < MONTH_VIEW_ROW_COUNT; row++) {
        data.push([]);
        for (var col = 0; col < MONTH_VIEW_COL_COUNT; col++) {
            data[row].push(addMonths(viewDate, index++));
        }
    }
    return data;
}
export function moveInMonthView(date, action) {
    switch (action) {
        case CalendarNavigationAction.NextCell:
            return addMonths(date, 1);
        case CalendarNavigationAction.PrevCell:
            return subMonths(date, 1);
        case CalendarNavigationAction.LowerCell:
            return addMonths(date, MONTH_VIEW_COL_COUNT);
        case CalendarNavigationAction.UpperCell:
            return subMonths(date, MONTH_VIEW_COL_COUNT);
        case CalendarNavigationAction.StartCell:
        case CalendarNavigationAction.FirstCell:
            return setMonth(date, 0);
        case CalendarNavigationAction.EndCell:
        case CalendarNavigationAction.LastCell:
            return setMonth(date, 11);
        case CalendarNavigationAction.PrevView:
            return subYears(date, 1);
        case CalendarNavigationAction.NextView:
            return addYears(date, 1);
        default:
            return date;
    }
}
