import { __read } from "tslib";
import { useMemo, useState } from 'react';
import { getDateWithTime } from './utils';
export function useDatePickerState(props) {
    var onChange = props.onChange, _a = props.value, propValue = _a === void 0 ? null : _a;
    var value = useMemo(function () { return (propValue ? new Date(propValue) : null); }, [propValue]);
    var _b = __read(useState(false), 2), isOpen = _b[0], setOpen = _b[1];
    function handleSetValue(event) {
        if (isOpen) {
            setOpen(false);
        }
        if (event.value && value) {
            event.value = getDateWithTime(event.value, value);
        }
        onChange === null || onChange === void 0 ? void 0 : onChange({ value: event.value });
    }
    return {
        value: value,
        setValue: handleSetValue,
        isOpen: isOpen,
        setOpen: setOpen,
    };
}
