import { DateInputValueProps, DateValue, MaybeDateValue } from '../../shared/types';
import { DateTimeEditableSegmentTypes, DateTimeSegment } from './types';
export interface UseDateTimeFieldStateProps extends DateInputValueProps<MaybeDateValue, Date | null> {
    min?: DateValue;
    max?: DateValue;
    disabled?: boolean;
    readOnly?: boolean;
    placeholder?: DateValue;
    formatOptions?: Intl.DateTimeFormatOptions;
}
export interface UseDateTimeFieldStateResult {
    resolvedOptions: Intl.ResolvedDateTimeFormatOptions;
    segments: DateTimeSegment[];
    setSegmentValue: (type: DateTimeEditableSegmentTypes, value: number | null) => void;
    increment: (type: DateTimeEditableSegmentTypes) => void;
    decrement: (type: DateTimeEditableSegmentTypes) => void;
    extraIncrement: (type: DateTimeEditableSegmentTypes) => void;
    extraDecrement: (type: DateTimeEditableSegmentTypes) => void;
    incrementToMax: (type: DateTimeEditableSegmentTypes) => void;
    decrementToMin: (type: DateTimeEditableSegmentTypes) => void;
}
export declare function useDateTimeFieldState(props: UseDateTimeFieldStateProps): UseDateTimeFieldStateResult;
