import { HTMLAttributes } from 'react';
import { PressProps } from '../../interactions/press';
export interface UseSpinButtonProps {
    min?: number;
    max?: number;
    value?: number;
    textValue?: string;
    disabled?: boolean;
    readOnly?: boolean;
    required?: boolean;
    onIncrement?: () => void;
    onExtraIncrement?: () => void;
    onDecrement?: () => void;
    onExtraDecrement?: () => void;
    onIncrementToMax?: () => void;
    onDecrementToMin?: () => void;
}
export interface UseSpinButtonResult<T extends HTMLElement> {
    spinButtonProps: HTMLAttributes<T>;
    incrementButtonProps: PressProps<HTMLElement>;
    decrementButtonProps: PressProps<HTMLElement>;
}
export declare function useSpinButton<T extends HTMLElement = HTMLElement>(props: UseSpinButtonProps): UseSpinButtonResult<T>;
