import { __assign } from "tslib";
import { useRef } from 'react';
import { useFocusable } from '../../interactions/focusable';
import { setCursorToEnd } from '../../libs/dom-utils';
import { useIsomorphicLayoutEffect as useLayoutEffect } from '../../libs/isomorphic-layout-effect';
export function useTextField(props, inputRef) {
    var _a = props.elementType, elementType = _a === void 0 ? 'input' : _a, _b = props.type, type = _b === void 0 ? 'text' : _b, _c = props.autoComplete, autoComplete = _c === void 0 ? 'off' : _c, onChange = props.onChange, onBlur = props.onBlur, disabled = props.disabled, value = props.value, defaultValue = props.defaultValue, min = props.min, minLength = props.minLength, maxLength = props.maxLength, max = props.max, readOnly = props.readOnly, name = props.name, onFocus = props.onFocus, placeholder = props.placeholder, required = props.required, pattern = props.pattern, inputMode = props.inputMode, id = props.id;
    var focusableProps = useFocusable(props, inputRef).focusableProps;
    var propsRef = useRef({
        elementType: elementType,
        autoFocus: props.autoFocus,
        inputRef: inputRef,
    });
    var additionalProps = {};
    if (elementType === 'input') {
        additionalProps = { type: type };
    }
    useLayoutEffect(function () {
        // By default autofocus set cursor at start position when element type is textarea.
        if (propsRef.current.elementType === 'textarea' && propsRef.current.autoFocus) {
            setCursorToEnd(propsRef.current.inputRef.current);
        }
    }, []);
    return {
        inputProps: __assign(__assign({ disabled: disabled, value: value, defaultValue: defaultValue, min: min, minLength: minLength, maxLength: maxLength, max: max, readOnly: readOnly, name: name, placeholder: placeholder, required: required, id: id, inputMode: inputMode, pattern: pattern, 'aria-activedescendant': props['aria-activedescendant'], 'aria-autocomplete': props['aria-autocomplete'], 'aria-haspopup': props['aria-haspopup'], 'aria-multiline': props['aria-multiline'], 'aria-placeholder': props['aria-placeholder'], 'aria-readonly': props['aria-readonly'], 'aria-required': required || undefined, onFocus: onFocus, onChange: onChange, onBlur: onBlur, autoComplete: autoComplete }, focusableProps), additionalProps),
    };
}
