"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useFocusable = void 0;
var react_1 = require("react");
var dom_utils_1 = require("../../libs/dom-utils");
function useFocusable(props, ref) {
    var autoFocus = props.autoFocus, disabled = props.disabled, tabIndex = props.tabIndex;
    (0, react_1.useEffect)(function () {
        if (autoFocus) {
            (0, dom_utils_1.focusElement)(ref.current);
        }
    }, [autoFocus, ref]);
    return {
        focusableProps: {
            tabIndex: disabled ? -1 : tabIndex,
        },
    };
}
exports.useFocusable = useFocusable;
