"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useHover = void 0;
var tslib_1 = require("tslib");
var react_1 = require("react");
function useHover(props) {
    var _a = tslib_1.__read((0, react_1.useState)(false), 2), isHovered = _a[0], setHovered = _a[1];
    var propsRef = (0, react_1.useRef)({});
    // Use ref as cache for reuse props inside memo hook.
    propsRef.current = { disabled: props.disabled };
    var hoverProps = (0, react_1.useMemo)(function () {
        var props = {};
        props.onPointerEnter = function (event) {
            var disabled = propsRef.current.disabled;
            if (disabled || event.pointerType !== 'mouse') {
                return;
            }
            setHovered(true);
        };
        props.onPointerLeave = function () {
            setHovered(false);
        };
        return props;
    }, []);
    return {
        isHovered: isHovered,
        hoverProps: hoverProps,
    };
}
exports.useHover = useHover;
