"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useKeyBinding = void 0;
var react_1 = require("react");
function useKeyBinding(props) {
    var bind = props.bind, onAction = props.onAction, disabled = props.disabled;
    var partialPropsRef = (0, react_1.useRef)({ onAction: onAction });
    partialPropsRef.current.onAction = onAction;
    (0, react_1.useEffect)(function () {
        if (disabled) {
            return;
        }
        var listener = function (event) {
            if (bind === event.code) {
                partialPropsRef.current.onAction(event);
            }
        };
        document.addEventListener('keyup', listener);
        return function () {
            document.removeEventListener('keyup', listener);
        };
    }, [disabled, bind]);
}
exports.useKeyBinding = useKeyBinding;
