"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.installPointerEvent = void 0;
var tslib_1 = require("tslib");
function installPointerEvent() {
    var FakePointerEvent = /** @class */ (function (_super) {
        tslib_1.__extends(FakePointerEvent, _super);
        // eslint-disable-next-line no-undef
        function FakePointerEvent(type, eventInitDict) {
            var _this = _super.call(this, type, eventInitDict) || this;
            _this._eventInitDict = eventInitDict;
            return _this;
        }
        Object.defineProperty(FakePointerEvent.prototype, "pointerId", {
            get: function () {
                var _a;
                return (_a = this._eventInitDict.pointerId) !== null && _a !== void 0 ? _a : 0;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FakePointerEvent.prototype, "pointerType", {
            get: function () {
                var _a;
                return (_a = this._eventInitDict.pointerType) !== null && _a !== void 0 ? _a : 'mouse';
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FakePointerEvent.prototype, "isPrimary", {
            get: function () {
                var _a;
                return (_a = this._eventInitDict.isPrimary) !== null && _a !== void 0 ? _a : false;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FakePointerEvent.prototype, "pressure", {
            get: function () {
                var _a;
                return ((_a = this._eventInitDict.pressure) !== null && _a !== void 0 ? _a : this.buttons) ? 0.5 : 0;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FakePointerEvent.prototype, "height", {
            get: function () {
                var _a;
                return (_a = this._eventInitDict.height) !== null && _a !== void 0 ? _a : 0;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FakePointerEvent.prototype, "width", {
            get: function () {
                var _a;
                return (_a = this._eventInitDict.width) !== null && _a !== void 0 ? _a : 0;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FakePointerEvent.prototype, "tiltX", {
            get: function () {
                var _a;
                return (_a = this._eventInitDict.tiltX) !== null && _a !== void 0 ? _a : 0;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FakePointerEvent.prototype, "tiltY", {
            get: function () {
                var _a;
                return (_a = this._eventInitDict.tiltY) !== null && _a !== void 0 ? _a : 0;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FakePointerEvent.prototype, "tangentialPressure", {
            get: function () {
                var _a;
                return (_a = this._eventInitDict.tangentialPressure) !== null && _a !== void 0 ? _a : 0;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FakePointerEvent.prototype, "twist", {
            get: function () {
                var _a;
                return (_a = this._eventInitDict.twist) !== null && _a !== void 0 ? _a : 0;
            },
            enumerable: false,
            configurable: true
        });
        FakePointerEvent.prototype.getCoalescedEvents = function () {
            return [];
        };
        FakePointerEvent.prototype.getPredictedEvents = function () {
            return [];
        };
        return FakePointerEvent;
    }(MouseEvent));
    beforeAll(function () {
        // @ts-expect-error
        global.PointerEvent = FakePointerEvent;
    });
    afterAll(function () {
        // @ts-expect-error
        delete global.PointerEvent;
    });
}
exports.installPointerEvent = installPointerEvent;
