"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useListeners = void 0;
var react_1 = require("react");
/* eslint-enable no-undef */
function useListeners() {
    var globalListeners = (0, react_1.useRef)(new Map());
    /* eslint-disable no-undef */
    var addListener = (0, react_1.useCallback)(function (eventTarget, type, listener, options) {
        /* eslint-enable no-undef */
        globalListeners.current.set(listener, { type: type, eventTarget: eventTarget, options: options });
        eventTarget.addEventListener(type, listener, options);
    }, []);
    /* eslint-disable no-undef */
    var removeListener = (0, react_1.useCallback)(function (eventTarget, type, listener, options) {
        /* eslint-enable no-undef */
        eventTarget.removeEventListener(type, listener, options);
        globalListeners.current.delete(listener);
    }, []);
    var removeAllListeners = (0, react_1.useCallback)(function () {
        globalListeners.current.forEach(function (value, key) {
            removeListener(value.eventTarget, value.type, key, value.options);
        });
    }, [removeListener]);
    (0, react_1.useEffect)(function () {
        return removeAllListeners;
    }, [removeAllListeners]);
    return { addListener: addListener, removeListener: removeListener, removeAllListeners: removeAllListeners };
}
exports.useListeners = useListeners;
