"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useCollection = void 0;
var react_1 = require("react");
var CollectionBuilder_1 = require("./CollectionBuilder");
function useCollection(props, factory) {
    var children = props.children;
    var factoryRef = (0, react_1.useRef)(factory);
    factoryRef.current = factory;
    return (0, react_1.useMemo)(function () {
        var builder = new CollectionBuilder_1.CollectionBuilder();
        var nodes = builder.build({ children: children });
        return factoryRef.current(nodes);
    }, [children]);
}
exports.useCollection = useCollection;
