"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTabbables = void 0;
var focus_1 = require("../../focus");
function getTabbables(root, filter) {
    var walker = new focus_1.ElementTreeWalker(root, function (node) {
        var tabbable = (0, focus_1.isTabbable)(node);
        if (filter && tabbable) {
            return filter(node);
        }
        return tabbable;
    });
    var nodes = [];
    var regular = [];
    var index = 0;
    var node = null;
    while ((node = walker.next())) {
        var tabIndex = (0, focus_1.adjustedTabIndex)(node);
        if (tabIndex === 0) {
            regular.push(node);
        }
        else {
            nodes.push({
                index: index++,
                tabIndex: tabIndex,
                node: node,
            });
        }
    }
    return nodes
        .sort(function (a, b) { return (a.tabIndex === b.tabIndex ? a.index - b.index : a.tabIndex - b.tabIndex); })
        .map(function (v) { return v.node; })
        .concat(regular);
}
exports.getTabbables = getTabbables;
