export declare class ElementTreeWalker {
    private walker;
    private currentElement;
    constructor(root: HTMLElement, filter: (node: HTMLElement) => boolean);
    /**
     * Get root element
     */
    get root(): HTMLElement;
    /**
     * Get current element
     */
    get current(): HTMLElement | null;
    /**
     * Set current element
     */
    set current(node: HTMLElement | null);
    /**
     * Move to first element of root
     */
    first(): HTMLElement | null;
    /**
     * Move to last element of root
     */
    last(): HTMLElement | null;
    /**
     * Move to next element of root
     */
    next(): HTMLElement | null;
    /**
     * Move to previous element of root
     */
    previous(): HTMLElement | null;
}
