"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useFocusManager = exports.FocusManagerScope = void 0;
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var createFocusManager_1 = require("./createFocusManager");
var FocusManagerContext = (0, react_1.createContext)(null);
var FocusManagerScope = function (props) {
    var scopeRef = props.scopeRef, autoFocus = props.autoFocus, children = props.children;
    var manager = (0, react_1.useMemo)(function () { return (0, createFocusManager_1.createFocusManager)(scopeRef); }, [scopeRef]);
    (0, react_1.useEffect)(function () {
        if (autoFocus) {
            manager.focusFirst();
        }
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    return react_1.default.createElement(FocusManagerContext.Provider, { value: manager }, children);
};
exports.FocusManagerScope = FocusManagerScope;
function useFocusManager() {
    var manager = (0, react_1.useContext)(FocusManagerContext);
    if (!manager) {
        throw new Error('Could not find focus manager context value. Please ensure the component is wrapped in a <FocusManagerScope />');
    }
    return manager;
}
exports.useFocusManager = useFocusManager;
