import { RefObject } from 'react';
import { FocusNavigationOptions } from './FocusNavigation';
declare type FocusOptions = {
    preventScroll?: boolean;
    tabbable?: boolean;
};
declare type FocusManagerOptions = FocusOptions & FocusNavigationOptions;
export interface FocusManager {
    focusFirst(options?: FocusOptions): HTMLElement | null;
    focusLast(options?: FocusOptions): HTMLElement | null;
    focusNext(options?: FocusManagerOptions): HTMLElement | null;
    focusPrevious(options?: FocusManagerOptions): HTMLElement | null;
}
export declare function createFocusManager<T extends HTMLElement>(scopeRef: RefObject<T>): FocusManager;
export {};
