"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isFocusable = void 0;
var dom_utils_1 = require("../dom-utils");
var utils_1 = require("./utils");
var FOCUSABLE_SELECTORS = [
    '[contenteditable]:not([contenteditable="false"])',
    '[tabindex]',
    'a[href]',
    'area[href]',
    'audio[controls]',
    'button',
    'details',
    'details>summary:first-of-type',
    'input',
    'select',
    'textarea',
    'video[controls]',
    'iframe',
].join(',');
function isFocusable(node) {
    if (!(0, utils_1.matches)(node, FOCUSABLE_SELECTORS) ||
        (0, utils_1.isHiddenInput)(node) ||
        node.disabled ||
        (0, dom_utils_1.isHidden)(node)) {
        return false;
    }
    return true;
}
exports.isFocusable = isFocusable;
