"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createDomWalker = void 0;
function createDomWalker(root, predicate) {
    var acceptNode = {
        acceptNode: function (node) {
            if (predicate(node)) {
                return NodeFilter.FILTER_ACCEPT;
            }
            return NodeFilter.FILTER_SKIP;
        },
    };
    // IE11 require use function instead object.
    var safeFilter = acceptNode;
    var walker = document.createTreeWalker(root, NodeFilter.SHOW_ELEMENT, safeFilter, 
    // IE11 require last argument
    /* @ts-expect-error */
    false);
    return walker;
}
exports.createDomWalker = createDomWalker;
