"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isRadioInput = exports.isHiddenInput = exports.isIframe = exports.isInput = exports.matches = void 0;
var protoMatches = null;
if (typeof Element !== 'undefined') {
    protoMatches =
        Element.prototype.matches ||
            Element.prototype.webkitMatchesSelector ||
            // @ts-expect-error
            Element.prototype.matchesSelector ||
            // @ts-expect-error
            Element.prototype.mozMatchesSelector ||
            // @ts-expect-error
            Element.prototype.msMatchesSelector;
}
function matches(node, selectors) {
    return protoMatches ? protoMatches.call(node, selectors) : false;
}
exports.matches = matches;
function isInput(node) {
    return node.tagName === 'INPUT';
}
exports.isInput = isInput;
function isIframe(node) {
    return node.tagName === 'IFRAME';
}
exports.isIframe = isIframe;
function isHiddenInput(node) {
    return isInput(node) && node.type === 'hidden';
}
exports.isHiddenInput = isHiddenInput;
function isRadioInput(node) {
    return isInput(node) && node.type === 'radio';
}
exports.isRadioInput = isRadioInput;
