"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useSlots = void 0;
var react_1 = require("react");
var SlotMap_1 = require("./SlotMap");
function useSlots(props, options) {
    if (options === void 0) { options = {}; }
    var children = props.children;
    var defaultSlot = options.defaultSlot;
    var slots = (0, react_1.useMemo)(function () {
        return new SlotMap_1.SlotMap(children, { defaultSlot: defaultSlot });
    }, [children, defaultSlot]);
    return slots;
}
exports.useSlots = useSlots;
