"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SSRProvider = exports.SSRContext = exports.initialContextValue = void 0;
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
/**
 * @internal
 */
exports.initialContextValue = { value: 0, id: 0 };
exports.SSRContext = (0, react_1.createContext)(exports.initialContextValue);
/**
 * Provider that synchronizes the layout data when the application is hydrated.
 *
 * @example
 * const Root = () => (
 *   <SSRProvider>
 *     <App />
 *   </SSRProvider>
 * )
 */
var SSRProvider = function (_a) {
    var children = _a.children;
    var context = (0, react_1.useContext)(exports.SSRContext);
    var value = (0, react_1.useMemo)(function () {
        return {
            value: 0,
            id: context === exports.initialContextValue ? 0 : ++context.id,
        };
    }, [context]);
    return react_1.default.createElement(exports.SSRContext.Provider, { value: value }, children);
};
exports.SSRProvider = SSRProvider;
