"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VirtualCollection = void 0;
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var useVirtualized_1 = require("./useVirtualized");
function VirtualCollection(props) {
    var collection = props.collection, children = props.children, estimate = props.estimate, focusedIndex = props.focusedIndex;
    var _a = (0, useVirtualized_1.useVirtualized)({
        items: collection,
        renderElement: function (_a) {
            var element = _a.element, style = _a.style;
            return (react_1.default.createElement("div", { style: style }, children({ element: element })));
        },
        estimate: estimate,
        focusedIndex: focusedIndex,
    }), containerProps = _a.containerProps, innerProps = _a.innerProps, virtualItems = _a.virtualItems;
    return (react_1.default.createElement("div", { ref: containerProps.ref, style: tslib_1.__assign(tslib_1.__assign({}, containerProps.style), { height: props.height, maxHeight: props.maxHeight }) },
        react_1.default.createElement("div", { style: innerProps.style }, virtualItems)));
}
exports.VirtualCollection = VirtualCollection;
