"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useVirtualized = void 0;
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var react_virtual_1 = require("react-virtual");
function useVirtualized(props) {
    var estimate = props.estimate, items = props.items, renderElement = props.renderElement, _a = props.focusedIndex, focusedIndex = _a === void 0 ? null : _a;
    var containerRef = (0, react_1.useRef)(null);
    var estimateSize = (0, react_1.useCallback)(function (index) {
        return typeof estimate === 'number' ? estimate : estimate(items[index]);
    }, [estimate, items]);
    var virtualizer = (0, react_virtual_1.useVirtual)({
        size: items.length,
        parentRef: containerRef,
        estimateSize: estimateSize,
    });
    (0, react_1.useEffect)(function () {
        if (focusedIndex !== null) {
            virtualizer.scrollToIndex(focusedIndex, { align: 'auto' });
        }
    }, [focusedIndex, virtualizer, items.length, estimate]);
    return {
        innerProps: {
            style: {
                position: 'relative',
                height: virtualizer.totalSize,
            },
        },
        containerProps: {
            style: {
                overflowY: 'auto',
            },
            ref: containerRef,
        },
        virtualItems: virtualizer.virtualItems.map(function (item) { return (react_1.default.createElement(react_1.Fragment, { key: item.key }, renderElement({
            element: items[item.index],
            style: {
                transform: "translateY(".concat(item.start, "px)"),
                position: 'absolute',
                top: 0,
                left: 0,
            },
        }))); }),
    };
}
exports.useVirtualized = useVirtualized;
