"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useMultipleCalendarState = void 0;
var tslib_1 = require("tslib");
var useSingleCalendarState_1 = require("./useSingleCalendarState");
var utils_1 = require("./utils");
function useMultipleCalendarState(props) {
    var value = props.value, defaultValue = props.defaultValue, onChange = props.onChange, restProps = tslib_1.__rest(props, ["value", "defaultValue", "onChange"]);
    var singleState = (0, useSingleCalendarState_1.useSingleCalendarState)(tslib_1.__assign(tslib_1.__assign({}, restProps), { value: value === null || value === void 0 ? void 0 : value[0], onChange: function (event) {
            var _a;
            var values = (_a = value === null || value === void 0 ? void 0 : value.slice()) !== null && _a !== void 0 ? _a : [];
            var index = values.findIndex(function (val) { return (0, utils_1.isEqualDate)(val, event.value); });
            if (index !== -1) {
                values.splice(index, 1);
            }
            else {
                values.push(event.value);
            }
            onChange === null || onChange === void 0 ? void 0 : onChange({ value: values });
        } }));
    function getCellState(cellValue, viewDate) {
        var _a;
        var baseCellState = singleState.getCellState(cellValue, viewDate);
        return tslib_1.__assign(tslib_1.__assign({}, baseCellState), { isSelected: (_a = value === null || value === void 0 ? void 0 : value.some(function (val) { return (0, utils_1.isSameCell)(singleState.activeView, val, cellValue); })) !== null && _a !== void 0 ? _a : false });
    }
    return tslib_1.__assign(tslib_1.__assign({}, singleState), { mode: 'multiple', value: value, getCellState: getCellState });
}
exports.useMultipleCalendarState = useMultipleCalendarState;
