"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useRangeCalendarState = void 0;
var tslib_1 = require("tslib");
var react_1 = require("react");
var useSingleCalendarState_1 = require("./useSingleCalendarState");
var utils_1 = require("./utils");
function useRangeCalendarState(props) {
    var _a;
    var value = props.value, defaultValue = props.defaultValue, onChange = props.onChange, restProps = tslib_1.__rest(props, ["value", "defaultValue", "onChange"]);
    var _b = tslib_1.__read((0, react_1.useState)(null), 2), highlightedDate = _b[0], setHighlightedDate = _b[1];
    var singleState = (0, useSingleCalendarState_1.useSingleCalendarState)(tslib_1.__assign(tslib_1.__assign({}, restProps), { value: (_a = value === null || value === void 0 ? void 0 : value.start) !== null && _a !== void 0 ? _a : undefined, onChange: function (event) {
            setHighlightedDate(highlightedDate ? null : event.value);
            onChange === null || onChange === void 0 ? void 0 : onChange({ value: (0, utils_1.createRange)(highlightedDate, event.value) });
        } }));
    var activeView = singleState.activeView, focusedDate = singleState.focusedDate, focusDate = singleState.focusDate, getBaseCellState = singleState.getCellState;
    var highlightedRange = highlightedDate
        ? (0, utils_1.createRange)(highlightedDate, focusedDate)
        : value && (0, utils_1.createRange)(value.start, value.end);
    function highlightDate(date) {
        if (highlightedDate) {
            focusDate(date);
        }
    }
    function getCellState(cellValue, viewDate) {
        var baseCellState = getBaseCellState(cellValue, viewDate);
        var isHighlighted = highlightedRange
            ? (0, utils_1.isInRange)(activeView, cellValue, highlightedRange)
            : false;
        var isHighlightedStart = (highlightedRange === null || highlightedRange === void 0 ? void 0 : highlightedRange.start)
            ? (0, utils_1.isSameCell)(activeView, cellValue, highlightedRange.start)
            : false;
        var isHighlightedEnd = (highlightedRange === null || highlightedRange === void 0 ? void 0 : highlightedRange.end)
            ? (0, utils_1.isSameCell)(activeView, cellValue, highlightedRange.end)
            : false;
        var hasHighlightDate = highlightedDate
            ? (0, utils_1.isSameCell)(activeView, cellValue, highlightedDate)
            : false;
        var isRangePreview = Boolean(highlightedDate) && isHighlighted;
        var isSelectionStart = isRangePreview
            ? isHighlightedStart && hasHighlightDate
            : isHighlightedStart;
        var isSelectionEnd = isRangePreview ? isHighlightedEnd && hasHighlightDate : isHighlightedEnd;
        return tslib_1.__assign(tslib_1.__assign({}, baseCellState), { isDisabled: baseCellState.isDisabled || !(0, utils_1.isSameView)(activeView, cellValue, viewDate), isRangePreview: Boolean(highlightedDate) && isHighlighted, isRangePreviewStart: isRangePreview && isHighlightedStart, isRangePreviewEnd: isRangePreview && isHighlightedEnd, isRangeSelected: !highlightedDate && isHighlighted, isSelectionStart: isRangePreview
                ? isHighlightedStart && hasHighlightDate
                : isHighlightedStart, isSelectionEnd: isRangePreview ? isHighlightedEnd && hasHighlightDate : isHighlightedEnd, isSelected: isSelectionStart || isSelectionEnd });
    }
    return tslib_1.__assign(tslib_1.__assign({}, singleState), { mode: 'range', value: value, highlightDate: highlightDate, getCellState: getCellState });
}
exports.useRangeCalendarState = useRangeCalendarState;
