import { DayOfWeek } from '../../../libs/i18n';
import { DateRangeValue, RangeValue } from '../../../shared/types';
import { CalendarNavigationAction, CalendarView, CalendarViewData } from '../types';
export { isEqual as isEqualDate } from '../../../internal/date';
export declare function createRange(start: Date, end: Date): RangeValue<Date>;
export declare function createRange(start: Date | null, end: Date | null): DateRangeValue;
export declare function startOfView(view: CalendarView, value: Date): Date;
export declare function endOfView(view: CalendarView, date: Date): Date;
export declare function startOfCell(view: CalendarView, date: Date): Date;
export declare function durationInViews(view: CalendarView, start: Date, end: Date): number;
export declare function addViews(view: CalendarView, date: Date, amount: number): Date;
export declare function subViews(view: CalendarView, date: Date, amount: number): Date;
export declare function nearest(view: CalendarView, candidate: Date, min: Date, total: number): Date;
export declare function isSameView(view: CalendarView, leftDate: Date, rightDate: Date): boolean;
export declare function isInRange(view: CalendarView, candidate: Date, range: DateRangeValue): boolean;
export declare function isSameCell(view: CalendarView, leftDate: Date, rightDate: Date): boolean;
export declare function clampDate(date: Date, min: Date, max: Date): Date;
export declare function getViewData(view: CalendarView, viewDate: Date, options?: {
    firstDayOfWeek?: DayOfWeek;
}): Date[][];
export declare function move(view: CalendarView, date: Date, action: CalendarNavigationAction, options?: {
    firstDayOfWeek?: DayOfWeek;
}): Date;
export declare function closestViewDate(view: CalendarView, start: Date, total: number, target: Date): Date;
export declare function getViewDate(view: CalendarView, baseDate: Date, focusedDate: Date): Date;
export declare function getViews(view: CalendarView, baseDate: Date, count: number, options?: {
    firstDayOfWeek?: DayOfWeek;
}): CalendarViewData[];
