"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.moveInMonthView = exports.getMonthViewData = exports.durationInMonthViews = void 0;
var date_1 = require("../../../internal/date");
var types_1 = require("../types");
var MONTH_VIEW_ROW_COUNT = 4;
var MONTH_VIEW_COL_COUNT = 3;
function durationInMonthViews(start, end) {
    return end.getFullYear() - start.getFullYear();
}
exports.durationInMonthViews = durationInMonthViews;
function getMonthViewData(viewDate) {
    var data = [];
    for (var row = 0, index = 0; row < MONTH_VIEW_ROW_COUNT; row++) {
        data.push([]);
        for (var col = 0; col < MONTH_VIEW_COL_COUNT; col++) {
            data[row].push((0, date_1.addMonths)(viewDate, index++));
        }
    }
    return data;
}
exports.getMonthViewData = getMonthViewData;
function moveInMonthView(date, action) {
    switch (action) {
        case types_1.CalendarNavigationAction.NextCell:
            return (0, date_1.addMonths)(date, 1);
        case types_1.CalendarNavigationAction.PrevCell:
            return (0, date_1.subMonths)(date, 1);
        case types_1.CalendarNavigationAction.LowerCell:
            return (0, date_1.addMonths)(date, MONTH_VIEW_COL_COUNT);
        case types_1.CalendarNavigationAction.UpperCell:
            return (0, date_1.subMonths)(date, MONTH_VIEW_COL_COUNT);
        case types_1.CalendarNavigationAction.StartCell:
        case types_1.CalendarNavigationAction.FirstCell:
            return (0, date_1.setMonth)(date, 0);
        case types_1.CalendarNavigationAction.EndCell:
        case types_1.CalendarNavigationAction.LastCell:
            return (0, date_1.setMonth)(date, 11);
        case types_1.CalendarNavigationAction.PrevView:
            return (0, date_1.subYears)(date, 1);
        case types_1.CalendarNavigationAction.NextView:
            return (0, date_1.addYears)(date, 1);
        default:
            return date;
    }
}
exports.moveInMonthView = moveInMonthView;
