"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDatePickerState = void 0;
var tslib_1 = require("tslib");
var react_1 = require("react");
var utils_1 = require("./utils");
function useDatePickerState(props) {
    var onChange = props.onChange, _a = props.value, propValue = _a === void 0 ? null : _a;
    var value = (0, react_1.useMemo)(function () { return (propValue ? new Date(propValue) : null); }, [propValue]);
    var _b = tslib_1.__read((0, react_1.useState)(false), 2), isOpen = _b[0], setOpen = _b[1];
    function handleSetValue(event) {
        if (isOpen) {
            setOpen(false);
        }
        if (event.value && value) {
            event.value = (0, utils_1.getDateWithTime)(event.value, value);
        }
        onChange === null || onChange === void 0 ? void 0 : onChange({ value: event.value });
    }
    return {
        value: value,
        setValue: handleSetValue,
        isOpen: isOpen,
        setOpen: setOpen,
    };
}
exports.useDatePickerState = useDatePickerState;
