"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDateRangePickerState = void 0;
var tslib_1 = require("tslib");
var react_1 = require("react");
var utils_1 = require("./utils");
function useDateRangePickerState(props) {
    var onChange = props.onChange, _a = props.value, value = _a === void 0 ? { start: null, end: null } : _a;
    var _b = tslib_1.__read((0, react_1.useState)(false), 2), isOpen = _b[0], setOpen = _b[1];
    function handleSetValue(event) {
        if (isOpen && event.value.start && event.value.end) {
            setOpen(false);
        }
        if (event.value.start && value.start) {
            event.value.start = (0, utils_1.getDateWithTime)(event.value.start, value.start);
        }
        if (event.value.end && value.end) {
            event.value.end = (0, utils_1.getDateWithTime)(event.value.end, value.end);
        }
        onChange === null || onChange === void 0 ? void 0 : onChange({ value: event.value });
    }
    return {
        value: value,
        setValue: handleSetValue,
        isOpen: isOpen,
        setOpen: setOpen,
    };
}
exports.useDateRangePickerState = useDateRangePickerState;
