export declare type DateTimeSegmentTypes = Intl.DateTimeFormatPartTypes;
export declare type DateTimeReadOnlySegmentTypes = 'era' | 'literal' | 'timeZoneName' | 'weekday';
export declare type DateTimeEditableSegmentTypes = Exclude<DateTimeSegmentTypes, DateTimeReadOnlySegmentTypes>;
export interface DateTimeReadOnlySegment {
    type: DateTimeReadOnlySegmentTypes;
    text: string;
    isEditable: false;
}
export interface DateTimeEditableSegment {
    type: DateTimeEditableSegmentTypes;
    text: string;
    value: number | null;
    min: number;
    max: number;
    isEditable: true;
    isPlaceholder: boolean;
    isValid: boolean;
    isDisabled: boolean;
}
export declare type DateTimeSegment = DateTimeReadOnlySegment | DateTimeEditableSegment;
