"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDateTimeField = void 0;
var tslib_1 = require("tslib");
var press_1 = require("../../interactions/press");
var focus_1 = require("../../libs/focus");
var uniq_id_1 = require("../../libs/uniq-id");
function useDateTimeField(props) {
    var focusNext = (0, focus_1.useFocusManager)().focusNext;
    var id = (0, uniq_id_1.useUniqId)(props.id);
    var pressProps = (0, press_1.usePress)({
        onPress: function (event) {
            var currentTarget = event.currentTarget, target = event.target, source = event.source;
            var activeElement = document.activeElement;
            if (source === 'keyboard') {
                return;
            }
            if (!currentTarget.contains(activeElement) ||
                (target !== activeElement && target !== currentTarget)) {
                focusNext({ from: target, tabbable: true });
            }
        },
    }).pressProps;
    var fieldProps = tslib_1.__assign(tslib_1.__assign({}, pressProps), { role: 'group', id: id, 'aria-label': props['aria-label'], 'aria-labelledby': props['aria-labelledby'] });
    var segmentProps = {
        'aria-controls': props['aria-controls'],
        'aria-haspopup': props['aria-haspopup'],
        'aria-invalid': props['aria-invalid'],
        'aria-labelledby': fieldProps['aria-labelledby'] || fieldProps.id,
    };
    return {
        fieldProps: fieldProps,
        segmentProps: segmentProps,
    };
}
exports.useDateTimeField = useDateTimeField;
