"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useOverlay = void 0;
var react_1 = require("react");
var OverlayManager_1 = require("./OverlayManager");
function useOverlay(options) {
    var visible = options.visible, onClose = options.onClose, essentialRefs = options.essentialRefs, _a = options.unsafe_strategy, closeStrategy = _a === void 0 ? 'pressdown' : _a;
    var optionsRef = (0, react_1.useRef)({ onClose: onClose, refs: essentialRefs, closeStrategy: closeStrategy });
    optionsRef.current.onClose = onClose;
    optionsRef.current.refs = essentialRefs;
    (0, react_1.useEffect)(function () {
        if (visible) {
            var options_1 = optionsRef.current;
            OverlayManager_1.OverlayManager.addOverlay(options_1);
            return function () {
                OverlayManager_1.OverlayManager.removeOverlay(options_1);
            };
        }
        return;
    }, [visible]);
}
exports.useOverlay = useOverlay;
