import { RefObject } from 'react';
import type { InputValueProps } from '../../shared/types/input';
export interface UseAutoResizeProps extends InputValueProps<string | ReadonlyArray<string> | number> {
    /**
     * Enable auto resize.
     */
    enabled: boolean;
    /**
     * @default 1
     */
    minRows?: number;
    /**
     * @default Infinity
     */
    maxRows?: number;
}
/**
 * Enable auto resize textarea when text changed.
 *
 * @param props - Props for the auto resize.
 * @param inputRef - Ref to the textarea html element.
 */
export declare function useAutoResize(props: UseAutoResizeProps, inputRef: RefObject<HTMLTextAreaElement>): void;
