"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useClearButton = void 0;
var react_1 = require("react");
var dom_utils_1 = require("../../libs/dom-utils");
function useClearButton(props, inputRef) {
    var onChange = props.onChange, value = props.value, disabled = props.disabled, readOnly = props.readOnly;
    var isInteractive = !(readOnly || disabled);
    var isActive = isInteractive && Boolean(value);
    var onPress = (0, react_1.useCallback)(function () {
        if (inputRef.current) {
            (0, dom_utils_1.focusWithoutScrolling)(inputRef.current);
            var syntheticEvent = Object.create({});
            syntheticEvent.target = inputRef.current;
            syntheticEvent.currentTarget = inputRef.current;
            inputRef.current.value = '';
            onChange === null || onChange === void 0 ? void 0 : onChange(syntheticEvent);
        }
    }, [inputRef, onChange]);
    return {
        isActive: isActive,
        buttonProps: {
            disabled: disabled,
            onPress: onPress,
            preventFocusOnPress: true,
            tabIndex: -1,
        },
    };
}
exports.useClearButton = useClearButton;
