"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.usePasswordField = void 0;
var tslib_1 = require("tslib");
var react_1 = require("react");
var dom_utils_1 = require("../../libs/dom-utils");
function usePasswordField(props, inputRef) {
    var disabled = props.disabled;
    var _a = tslib_1.__read((0, react_1.useState)(false), 2), isShown = _a[0], setShown = _a[1];
    var onPress = function () {
        setShown(!isShown);
        if (inputRef.current) {
            (0, dom_utils_1.focusWithoutScrolling)(inputRef.current);
        }
        // Use raf for set cursor at the end after layout changed.
        requestAnimationFrame(function () {
            (0, dom_utils_1.setCursorToEnd)(inputRef.current);
        });
    };
    return {
        isShown: isShown,
        buttonProps: {
            disabled: disabled,
            onPress: onPress,
            preventFocusOnPress: true,
            tabIndex: -1,
        },
        inputProps: {
            type: isShown ? 'text' : 'password',
        },
    };
}
exports.usePasswordField = usePasswordField;
