import { ElementType, InputHTMLAttributes, RefObject, TextareaHTMLAttributes } from 'react';
import type { CommonTextFieldProps } from './types';
export interface TextFieldProps extends CommonTextFieldProps {
    elementType?: ElementType;
}
export interface UseTextFieldResult<T> {
    inputProps: T;
}
export declare function useTextField<T extends HTMLInputElement | HTMLTextAreaElement>(props: TextFieldProps, inputRef: RefObject<T>): T extends HTMLTextAreaElement ? UseTextFieldResult<TextareaHTMLAttributes<T>> : UseTextFieldResult<InputHTMLAttributes<T>>;
