"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useToggle = void 0;
var tslib_1 = require("tslib");
var focusable_1 = require("../../interactions/focusable");
var press_1 = require("../../interactions/press");
var merge_props_1 = require("../../libs/merge-props");
var platform_1 = require("../../libs/platform");
// TODO: Add validation for exists aria-label or aria-labelledby.
function useToggle(props, inputRef) {
    var onChange = props.onChange, readOnly = props.readOnly, state = props.state, restProps = tslib_1.__rest(props, ["onChange", "readOnly", "state"]);
    var focusableProps = (0, focusable_1.useFocusable)(props, inputRef).focusableProps;
    var _a = (0, press_1.usePress)(props), isPressed = _a.isPressed, pressProps = _a.pressProps;
    return {
        isPressed: isPressed,
        rootProps: pressProps,
        inputProps: (0, merge_props_1.mergeProps)(restProps, focusableProps, {
            'aria-checked': props.checked,
            'aria-invalid': state === 'invalid' || undefined,
            // Use "aria-readonly" because "readOnly" available only for text fields,
            // see https://developer.mozilla.org/en-US/docs/Web/HTML/Attributes/readonly.
            'aria-readonly': readOnly || undefined,
            // https://bugzilla.mozilla.org/show_bug.cgi?id=654072
            autoComplete: (0, platform_1.isFirefox)() ? 'off' : undefined,
            onChange: readOnly ? undefined : onChange,
            type: 'checkbox',
        }),
    };
}
exports.useToggle = useToggle;
